# code taken from the excellent Distributed Programming with Ruby
# written by Mark Bates, Copyright 2010 Addison-Wesley
# requires ruby 1.8.x or ruby 1.9.x to run
# also depending on your firewall, you may need to open port 7647

require 'rinda/ring'

DRb.start_service
ring_server = Rinda::RingFinger.primary

threads = []

10.times do |th|
  threads << Thread.new do
    10.times do |i|
      service = ring_server.read([:count_service, nil])
      sleep(rand(2))
      puts "#{th}: #{i} (#{service.inspect})\n"
      updated_count = service[1] + 1
      puts "#{th}: #{i} (#{updated_count})\n"
      ring_server.write([:count_service, updated_count])
    end
  end
end

threads.each { |t| t.join }

service = ring_server.read([:count_service, nil])

puts service.inspect
